/*
** wifimgr.h
*/

/*
** Copyright (c) 2009, J.R. Oldroyd, Open Advisors Limited
** All rights reserved.
** 
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**       notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the author, the author's organization nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
** 
** THIS SOFTWARE IS PROVIDED BY OPEN ADVISORS LIMITED ''AS IS'' AND ANY
** EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL OPEN ADVISORS LIMITED BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
** $Id: wifimgr.h 57 2009-12-18 19:29:30Z jr $
*/

#define NETWORKS_FILE	"/etc/wpa_supplicant.conf"
#define RC_CONF_FILE	"/etc/rc.conf"

#define ICON_PATH	"/usr/local/share/wifimgr/icons"

#define PATH_CAT	"/bin/cat"
#define PATH_CP		"/bin/cp"
#define PATH_DIFF	"/usr/bin/diff"
#define PATH_IFCONFIG	"/sbin/ifconfig"
#define PATH_NETIF	"/etc/rc.d/netif"
#define PATH_SED	"/usr/bin/sed"
#define PATH_WIFIMGRSU	"/usr/local/libexec/wifimgrsu"

#define TMPDIR		"/tmp"

struct wifi_net {
	int			wn_enabled;
	char			wn_ssid[256];
	char			wn_key[256];
	char			wn_comment[256];
	int			wn_priority;
	char			wn_bssid[256];
	int			wn_chan;
	int			wn_rate;
	int			wn_security;
	int			wn_bars;
	struct wifi_net *	wn_next;
};

/* values for wn_security */
#define WN_SEC_NONE		0
#define WN_SEC_WEP		1
#define WN_SEC_WPA_PSK		2
#define WN_SEC_OTHER		3

/* values for gui_message() */
#define	MSG_INFO		0
#define	MSG_WARNING		1
#define	MSG_QUESTION		2
#define	MSG_ERROR		3
#define	MSG_INPUT		4
#define MSG_RESPONSE_OK		0
#define MSG_RESPONSE_FAIL	1
#define MSG_RESPONSE_YES	2
#define MSG_RESPONSE_NO		3

extern char *			wifi_if;

extern char *			ifconfig_associated_network(char *);
extern struct wifi_net *	build_network_list(char *);
extern int			save_networks_file(void);

extern int			nl_insert(struct wifi_net **, struct wifi_net *);
extern int			nl_delete_list(struct wifi_net **);

extern int			gui_changes;
extern char			gui_response[];
extern int			gui_init();
extern int			gui_message(char *, int);
extern void			gui_loop();
